unit xmpdsp;

interface

uses
  Windows, xmpfunc;

type
  PSingle = ^Single;
  PXMPFORMAT = ^XMPFORMAT;

const
  XMPDSP_FACE = 1; // "face"

  XMPDSP_FLAG_MULTI = 1; // supports multiple instances
  XMPDSP_FLAG_TAIL = 2; // effect has a tail
  XMPDSP_FLAG_NODSP = 4; // no DSP processing (a "general" plugin), exclude from "DSP" saved settings

type
  TAbout = procedure(Win : HWND); stdcall;
  TNew = function : Pointer; stdcall;
  TFree = procedure(Inst : Pointer); stdcall;
  TGetDescription = function(Inst : Pointer) : PAnsiChar; stdcall;
  TConfig = procedure(Inst : Pointer; Win : HWND); stdcall;
  TGetConfig = function(Inst : Pointer; Config : Pointer) : DWORD; stdcall;
  TSetConfig = function(Inst : Pointer; Config : Pointer; Size : DWORD) : LongBool; stdcall;
  TNewTrack = procedure(Inst : Pointer; const AFile : PAnsiChar) stdcall;
  TSetFormat = procedure(Iinst : Pointer; const Form : PXMPFORMAT); stdcall;
  TReset = procedure(Inst : Pointer); stdcall;
  TProcess = function(Inst : Pointer; Data : PSingle; Count : DWORD) : DWORD; stdcall;

  TXMPDSP = packed record
    Flags : DWORD; // XMPDSP_FLAG_xxx
    Name : PAnsiChar; // plugin name
    About : TAbout; // OPTIONAL
    New : TNew; // create new plugin instance (return new instance handle)
    // the following all apply to a specific instance ("inst")
    Free : TFree; // free plugin instance
    GetDescription : TGetDescription; // get description
    Config : TConfig; // present config options to user (OPTIONAL)
    GetConfig : TGetConfig; // get config (return size of config data)
    SetConfig : TSetConfig; // apply config
    NewTrack : TNewTrack; // a track has been opened or closed (OPTIONAL)
    // the following are optional with the XMPDSP_FLAG_NODSP flag
    SetFormat : TSetFormat; // set sample format (if form=NULL output stopped)
    Reset : TReset; // reset DSP after seeking
    Process : TProcess; // process samples (return number of samples processed)
    // The Process function currently must return the same amount of data as it is given - it can't
    // shorten/stretch the sound. This restriction may (or may not ;)) be lifted in future.
  end;

implementation

end.